#include <windows.h>

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );

char szAppName[]= "MHello";	// Application, and Window class name

int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszArgs, int nCmdShow )
{
	HWND hWnd;
	MSG Msg;
	WNDCLASS WndClass;

	// Define Window Class
	WndClass.hInstance = hInst;
	WndClass.lpszClassName = szAppName;
	WndClass.lpfnWndProc = WndProc;
	WndClass.style = 0;	// No special styles

	// Set resources for the program: Icon, Cursor, Menu (we have none), and background
	WndClass.hIcon = LoadIcon( NULL, IDI_APPLICATION );
	WndClass.hCursor = LoadCursor( NULL, IDC_ARROW );
	WndClass.lpszMenuName = NULL;
	WndClass.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );

	WndClass.cbClsExtra = 0; // 'Extra' information about this window,
	WndClass.cbWndExtra = 0; // our program has none.

	// Register the class (this includes the 'WndProc')
	if( !RegisterClass( &WndClass ) )
	{
		MessageBox( NULL, "Error registering class", NULL, MB_ICONEXCLAMATION|MB_OK );
		return( 0 );
	}

	// Create the window, which will be our main window
	hWnd = CreateWindow( szAppName, "Hello", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
		HWND_DESKTOP, NULL, hInst, NULL );

	if( !hWnd )
	{
		MessageBox( NULL, "Error creating window", NULL, MB_ICONEXCLAMATION|MB_OK );
		return( 0 );
	}

	// Get the window visible, and update it
	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	// Message Loop.  Program sits here most of the time.
	while( GetMessage( &Msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &Msg );
		DispatchMessage( &Msg );
	}

	return( Msg.wParam );
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam )
{
	// This is the 'message handler', handling all messages sent to our window
	switch( Message )
	{
		case WM_PAINT:
			HDC DC;
			PAINTSTRUCT PaintStruct;
			DC = BeginPaint( hWnd, &PaintStruct );
			TextOut( DC, 0, 0, "Hello World", 11 );
			EndPaint( hWnd, &PaintStruct );
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			// Any unhandled messages are passed onto to the default handler.
			return( DefWindowProc( hWnd, Message, wParam, lParam ) );
	}
	return( 0 );
}
